//----------------------------------------------------------------------------
//	DATAPACKET.JS
//----------------------------------------------------------------------------

	function voiceInit() {
//----------------------------------------------------------------------------
		window.external.Voice.SetProxy(VoiceProxy1);
	}

	function objBrokerInit() {
//----------------------------------------------------------------------------
		window.external.ObjBroker.SetProxy(VoiceProxy1);
	}

	function senderEmail(p_strFullPacket) {
//----------------------------------------------------------------------------
		var l_strDataType = p_strFullPacket.substring(0, 3);
		var l_strSenderEmail;
		switch(l_strDataType)
		{
			case "VPT":
				l_strSenderEmail =
					p_strFullPacket.substring(5,p_strFullPacket.length);
				break;
			case "FRM":				
				l_strSenderEmail =
					p_strFullPacket.substring(55,p_strFullPacket.length);
				break;
			case "DCC":
				l_strSenderEmail =
					p_strFullPacket.substring(14,p_strFullPacket.length);
				break;
			case "SYS":
				var fullPacketArr = p_strFullPacket.split("~|");
				l_strSenderEmail = fullPacketArr[2];
				break;
		}
		return l_strSenderEmail;
	}


	function getCurrentStoreIDString() {
//----------------------------------------------------------------------------
// Converts current store id from integer to string with leading zeros.

		var l_strCurStore = new String(g_strCurrentStoreID);
		var l_nLeadingZeros = 6 - l_strCurStore.length;
		var l_strLeadingZeros = '';
		for (i = 0; i < l_nLeadingZeros; i++)
			l_strLeadingZeros += '0';
		return l_strLeadingZeros + l_strCurStore;
	}

	function BuildPacket(p_strPacketType,
						p_strPacketTransaction,
						p_strPacketData) {
//----------------------------------------------------------------------------

	// DECLARATIONS-----------------------------------------------------------
		this.m_strDataType 		= p_strPacketType;
		this.m_strPacketVersion = '1';
		this.m_strTransaction 	= p_strPacketTransaction;
		this.m_strSenderEmail 	= window.external.currentuser.email;
		
		this.m_strData			= '';		
		this.m_strVendorID		= '';
		this.m_strSkinColor		= '';
		this.m_strVendorData	= '';
		this.m_strFullPacket	= '';
		
	// SET MEMBER VARIABLES BEFORE CONCATENATING AND SENDING------------------
		switch(this.m_strDataType)
		{
			case 'VPT':
					if (this.m_strTransaction == 'A')
					{
						this.m_strVendorID = '~|' + getCurrentStoreIDString();
						
						// store only the version in vendor data
						var l_objTempVendors = new ActiveXObject("Vendors.Vendors.1");
						var l_objTempVendor  =
							l_objTempVendors.getVendorByID(this.m_strVendorID);
						this.m_strVendorData = '~|' + l_objTempVendor.Version + '~|';
					}	
					this.m_strData = '~|' + p_strPacketData;
				break;
	
			case 'FRM':
					if (this.m_strTransaction == 'A')
					{
						this.m_strVendorID = '~|' + getCurrentStoreIDString();
						
						// store only the version in vendor data
						var l_objTempVendors = new ActiveXObject("Vendors.Vendors.1");
						var l_objTempVendor  =
							l_objTempVendors.getVendorByID(this.m_strVendorID);
						this.m_strVendorData = '~|' + l_objTempVendor.Version + '~|';
					}	

					// framedata is passed in via p_strPacketData
					this.m_strData = '~|' + p_strPacketData;
				break;
				
			case 'DCC':
				// m_strDccData: 5 char string with trailing spaces					
					var l_strTemp = new String(p_strPacketData);
					var l_nstrLen = 5 - l_strTemp.length;
					for (i = 0; i < l_nstrLen; i++)
						l_strTemp += ' ';
					// assign new string to member var 
					this.m_strData = l_strTemp;
					
				// m_strVendorData: variable length string consisting of 
				// vendorname and vendorversion separated by '~|'
					this.m_strVendorData = '~|~|';
					
					// tests for a dccId passed to the function
					if (!(isNaN(parseInt(p_strPacketData))))
					{
						// get the dcc object
						var l_objTempDccs = new ActiveXObject("Dccs.Dccs.1");
						var l_objTempDcc  =
							l_objTempDccs.getDccById(parseInt(p_strPacketData));

						// get the vendor object from the dcc object
						var l_objTempVendors = new ActiveXObject("Vendors.Vendors.1");
						var l_objTempVendor  =
							l_objTempVendors.getVendorByID(l_objTempDcc.vendorID);
						this.m_strVendorData = l_objTempVendor.name + '~|'
										+ l_objTempVendor.Version + '~|';
					}
					
				// m_strSkinColor: 3 char string w/ leading zeros
					var l_strTempSkinColor =
						new String(window.external.currentuser.skincolor);
					var l_nLeadingZeros = 3 - l_strTempSkinColor.length;
					var l_strLeadingZeros = '';
					for (i = 0; i < l_nLeadingZeros; i++)
						l_strLeadingZeros += '0';
					this.m_strSkinColor =
						l_strLeadingZeros + l_strTempSkinColor;
				break;
				
			case 'SYS':
					// sys data passed in to p_strPacketData 
					this.m_strData = p_strPacketData;
				break;		
		}
		
		// build the packet
		this.m_strFullPacket = this.m_strDataType
							 + this.m_strPacketVersion
							 + this.m_strTransaction
							 + this.m_strVendorID
							 + this.m_strData
							 + this.m_strVendorData
							 + this.m_strSkinColor
							 + this.m_strSenderEmail;
				
		// send the packet
		window.external.Voice.SendData(m_strFullPacket);
	}
	
//----------------------------------------------------------------------------
//	PARSING FUNCTIONS
//----------------------------------------------------------------------------

	var arr_ParseFuncs = new Array();
		arr_ParseFuncs["VPT"] = "parseViewpointPacket(p_strFullPacket)";
		arr_ParseFuncs["FRM"] = "parseSyncFramePacket(p_strFullPacket)";
		arr_ParseFuncs["DCC"] = "parseDCCPacket(p_strFullPacket)";
		arr_ParseFuncs["SYS"] = "parseSYSPacket(p_strFullPacket)";
		

	function ParsePacket(p_strFullPacket) {
//----------------------------------------------------------------------------
		var retVal;
		var l_strDataType = p_strFullPacket.substring(0, 3);
		// read function to execute from array
		retVal = eval(arr_ParseFuncs[l_strDataType]);
		return retVal;
	}

	function parseViewpointPacket(p_strFullPacket) {
//----------------------------------------------------------------------------
//	User is getting a 3D viewpoint from their buddy. check the users settings 
//	before allowing the viewpoint to change.
		var retVal;
		
		// splitting creates a 4 element array here...
		var l_arrSplitPacket = p_strFullPacket.split("~|");

		var l_strVendorID 		= l_arrSplitPacket[1];
		var l_strMundoData 		= l_arrSplitPacket[2];
		var l_strVendorVersion	= l_arrSplitPacket[3];
		var l_strSenderEmail 	= l_arrSplitPacket[4];
		
		// check version data sent in packet vs. the user's version
		// for the same vendor
		var l_objVendors = new ActiveXObject("Vendors.Vendors.1");
		var l_objVendor = l_objVendors.getVendorByID(l_strVendorID);
		var l_nUserVersion = parseInt(l_objVendor.Version);
		var l_strVendorName = l_objVendor.name;
		
		var ERR_USER_HAS_NEWER_VERSION = 'Your friend has an older version of '
			+ l_strVendorName + '.\nWe are unable to complete this request.';
		var ERR_FRIEND_HAS_NEWER_VERSION = 'You have an older version of '
			+ l_strVendorName + '.\nWe are unable to complete this request.\n'
			+ 'Please go to the Update Manager and get the latest.';
		var ERR_USER2D_FRIEND3D = 'Your Mall Setting are set to Standard, but your friend is using Showcase.\n'
			+ 'Go to the Customize Section and change your Mall Setting to Showcase in order to complete this request.';
		
		// check for 3d availability
		if (!window.external.UseFlatMundo)
		{
			if (l_nUserVersion == parseInt(l_strVendorVersion))
			{
				// hide flatmundo if user is in a store
				if (divFlatMundoCtrl.style.visibility == 'visible')
				{
					hideElem(divFlatMundoCtrl);
					showElem(divTDMundoCtrl);		
					if (bTDMundoInited)
						LoadScene3dMundo(0);
				}
				TDMundoCtrl.SyncData = l_strMundoData;
			}
			else
			{
				// versions don't match
				if (l_nUserVersion > parseInt(l_strVendorVersion))
					alert(ERR_USER_HAS_NEWER_VERSION);
				else
					alert(ERR_FRIEND_HAS_NEWER_VERSION);
			}
		}
		else
		{
			// user settings disallow 3d mundo
			alert(ERR_USER2D_FRIEND3D);
		}

		retVal = l_strMundoData;

		return retVal;
	}

	function parseSyncFramePacket(p_strFullPacket) {
//----------------------------------------------------------------------------
//	User is getting a 2D viewpoint from their buddy. check the users settings 
//	and the scene to be loaded before allowing the viewpoint to change.
		var retVal;
		var l_bValidTransition = false;
		var l_strErrMsg;
		
		var l_arrSplitPacket = p_strFullPacket.split("~|");

		var l_strVendorID 		= l_arrSplitPacket[1];
		var l_strFlatMundoData	= l_arrSplitPacket[2];
		var l_strVendorVersion	= l_arrSplitPacket[3];
		var l_strSenderEmail 	= l_arrSplitPacket[4];
		
		// check version data sent in packet vs. the user's version
		// for the same vendor
		var l_objVendors = new ActiveXObject("Vendors.Vendors.1");
		var l_objVendor = l_objVendors.getVendorByID(l_strVendorID);
		var l_nUserVersion = parseInt(l_objVendor.Version);
		var l_strVendorName = l_objVendor.name;
		
		var ERR_USER_HAS_NEWER_VERSION = 'Your friend has an older version of '
			+ l_strVendorName + '.\nWe are unable to complete this request.';
		var ERR_FRIEND_HAS_NEWER_VERSION = 'You have an older version of '
			+ l_strVendorName + '.\nWe are unable to complete this request.\n'
			+ 'Please go to the Update Manager and get the latest.';
		var ERR_USER3D_FRIEND2D = 'Your Mall Setting are set to Showcase, but your friend is using Standard.\n'
			+ 'Go to the Customize Section and change your Mall Setting to Standard in order to complete this request.';
					  
		// check version data sent in packet vs. the user's version
		// for the same vendor
		var l_objVendors = new ActiveXObject("Vendors.Vendors.1");
		var l_objVendor = l_objVendors.getVendorByID(l_strVendorID);
		var l_nUserVersion = parseInt(l_objVendor.Version);

		// check for mall
		if (l_strVendorID == '000000')
		{
			// check if 
			if (window.external.UseFlatMundo)
			{
				if (l_nUserVersion == parseInt(l_strVendorVersion))
				{
					l_bValidTransition = true;
				}
				else
				{
					// versions don't match
				if (l_nUserVersion > parseInt(l_strVendorVersion))
					l_strErrMsg = ERR_USER_HAS_NEWER_VERSION;
				else
					l_strErrMsg = ERR_FRIEND_HAS_NEWER_VERSION;
				}
			}
			else
			{
				l_strErrMsg = ERR_USER3D_FRIEND2D;
			}
		}
		else
		{
			if (l_nUserVersion == parseInt(l_strVendorVersion))
			{
				l_bValidTransition = true;
			}
			else
			{
				// versions don't match
				if (l_nUserVersion > parseInt(l_strVendorVersion))
					l_strErrMsg = ERR_USER_HAS_NEWER_VERSION;
				else
					l_strErrMsg = ERR_FRIEND_HAS_NEWER_VERSION;
			}
		}
		if (l_bValidTransition)
		{
			if (divTDMundoCtrl.style.visibility == 'visible')
				hideElem(divTDMundoCtrl);
				
			initFlatMundo(l_strVendorID);
			showElem(divFlatMundoCtrl);		
			FlatMundoCtrl.syncData  = l_strFlatMundoData;
		}
		else
		{
			alert(l_strErrMsg);
		}
		retVal = l_strFlatMundoData;

		return retVal;
	}

	function BSCObject(p_strSkinColor) {
//----------------------------------------------------------------------------
		this.m_strSkinColor = p_strSkinColor;
	}

	function parseDCCPacket(p_strFullPacket) {
//----------------------------------------------------------------------------
		var retVal;
		
		// splitting creates a 3 element array here...
		var l_arrSplitPacket = p_strFullPacket.split("~|");
		
		var l_strVersion = l_arrSplitPacket[0].substring(3, 4);
		
		//l_strTransaction == A -- Add DCC, R -- Remove Dcc
		var l_strTransaction = l_arrSplitPacket[0].substring(4, 5);
		
		//l_strMannequinRepaint == R -- Repaint Mannequin
		var l_strMannequinRepaint = l_arrSplitPacket[0].substring(5,6);
		var l_strDccData = l_arrSplitPacket[0].substring(6, 11);
		var l_strVendorName = l_arrSplitPacket[0].substring(11, l_arrSplitPacket[0].length);

		var l_strVendorVersion = l_arrSplitPacket[1];
		var l_strSkinColor = l_arrSplitPacket[2].substring(0, 3);
		window.external.PageState("BSC") = new BSCObject(l_strSkinColor);
		var l_strSenderEmail = l_arrSplitPacket[2].substring(3, l_arrSplitPacket[2].length);

		retVal = l_strDccData;
		var userDcc = window.external.currentuser.GetDccForBuddy(l_strDccData);		
		// GetDccForBuddy() validates the existence of the dcc on the 
		// user's machine.  If the Dcc does not exist in the user Datebase,
		// the dccID will be -1 (tested below).
		
		if (userDcc.dccID > 0)
		{
			if (l_strTransaction == 'A')
			{
				objMannequin2.Component.addDcc(userDcc);
				var tmpColl = objMannequin2.Component.getDCCCollection();
				objMannequin2.DrawComponentOnColor(objMannequin2.component, parseInt(l_strSkinColor), 255,0,255);
			}
			else if (l_strTransaction == 'R')
			{
				
				var ocAllDCCs = objMannequin2.Component.getDCCCollection();
				ocAllDCCs.Empty();
				objMannequin2.DrawComponentOnColor(objMannequin2.Component,
												   parseInt(l_strSkinColor),
												   255,255,255);				
			}
			if (l_strMannequinRepaint == 'R')
			{
				objMannequin2.DrawComponentOnColor(objMannequin2.Component, parseInt(l_strSkinColor), 255,255,255);
			}
		}
		else
		{			
			// check for existence of vendor in database
			var l_objVENDORS = new ActiveXObject("Vendors.Vendors.1");
			var l_objVENDOR = l_objVENDORS.getVendorByName(l_strVendorName);
			
			if (l_objVENDOR)
			{
				
				// vendor exists, check version nums...
				if (parseInt(l_strVendorVersion) > parseInt(l_objVENDOR.Version))
				{
					// buddy has newer content, prompt user to update the vendor
					alert('Your friend has attempted to place a new item on their mannequin.\n'
							+ 'Please go to the Update Manager to download the latest '
							+ l_strVendorName + 'items');
				}
				else if (parseInt(l_strVendorVersion) < parseInt(l_objVENDOR.Version))
				{
					// user has newer content, dcc is obsolete
					alert('Your friend has attempted to place as item on their\n'
						+ 'mannequin that is not in the current ' + l_strVendorName
						+ ' catalog.\nSince this item has expired, there is no way to view it.');
				}
			}
		}
		
		return retVal;
	}

	function parseSYSPacket(p_strFullPacket) {
//----------------------------------------------------------------------------
		//alert('parseSYSpacket: ' + p_strFullPacket);
		var retVal;

		var l_strVersion = p_strFullPacket.substring(3, 4);
		var l_strTransaction = p_strFullPacket.substring(4, 5);

		switch(l_strTransaction)
		{
			case 'C':
			// COMMAND
				var fullPacketArr = p_strFullPacket.split("~|");
				var l_strCommand = fullPacketArr[1];
				var l_strSenderEmail = fullPacketArr[2];
				if (document.all['selectNameList']) refreshList();
				retVal = l_strCommand;
			break;
			case 'I':
			// INFO
				var fullPacketArr = p_strFullPacket.split("~|");
				var l_strBuddyName = fullPacketArr[1];
				var l_strSenderEmail = fullPacketArr[2];
				retVal = l_strBuddyName;
				
				// implemented on parent page
				onReceivedBuddyNameAndEmail();
			break;
			case 'A':
			// ANSWER
				var fullPacketArr = p_strFullPacket.split("~|");
				var l_strPacketData = fullPacketArr[1];
				if (l_strPacketData == "HangupCall")
				{
					onHangup();
				}
			
			break;
			case 'M':
			// MESSAGE
				var fullPacketArr = p_strFullPacket.split("~|");
			break;
		}
		return retVal;
	}
