//----------------------------------------------------------------------------
//	DRAGEVENTS.JS
//----------------------------------------------------------------------------

//	EVENT HANDLERS-----------------------------------------------------------
			
		
		function doMouseDown(elCurrent, eX, eY) {
//----------------------------------------------------------------------------
//	elCurrent:	element receiving the mousedown event
//	eX, eY:		mouse coordinates of event
//
//	COMMENTS:	Any element that implements this function as the event handler
//				automatically becomes a 'source'.  that element must then
//				implement 'doMouseDown' and 'doMouseUp' to complete the
//				functionality			
//----------------------------------------------------------------------------
			window.external.PlayAudio('dragslct.wav');
			elSource = new Source(elCurrent);
		}
		
		function doMouseMove(eX, eY) {
//----------------------------------------------------------------------------
//	eX, eY:		mouse coordinates of event
//----------------------------------------------------------------------------

			for (var i = 0; i < arrTargets.length; i++)
			{			
				// do not allow an object to be dropped on itself
				if (arrTargets[i].targetID != elSource.sourceID)
				{
					if (arrTargets[i].overTarget(eX, eY)) {
						if (arrTargets[i].acceptSource(elSource))
						{
							// image rollover
							document.all[arrTargets[i].targetID].src =
								document.all[arrTargets[i].targetID].altImg;
						}
					}
					else 
					{
						document.all[arrTargets[i].targetID].src =
							document.all[arrTargets[i].targetID].regImg;
					}

				}
			}
		}
			
		function doDragOff(id, obj)
		{
			switch(id)
			{
			case 1:
				// save
				imgSave.src = imgSave.regImg;
				break;
			case 2:
				// remove
				imgRemove.src = imgRemove.regImg;
				break;
			}
		}
		function doDragOver(id, obj)
		{
			switch(id)
			{
			case 1:
				imgSave.src = imgSave.altImg;
				window.external.PlayAudio('dragroll.wav');
				break;
			case 2:
				imgRemove.src = imgRemove.altImg;
				window.external.PlayAudio('dragroll.wav');
				break;
			}
		}

		function doMouseUp(eX, eY) {
//----------------------------------------------------------------------------
//	eX, eY:		screen coordinates of the event
//
//----------------------------------------------------------------------------
			mouseSourceDiffX = 0;
			mouseSourceDiffY = 0;
						
			for (var i = 0; i < arrTargets.length; i++)
			{
				if (arrTargets[i].targetID != elSource.sourceID)
				{
					if (arrTargets[i].overTarget(eX, eY))
					{
						if (arrTargets[i].acceptSource(elSource))
						{
							// take appropriate action to add source to target
							arrTargets[i].dropSourceOnTarget(elSource);
						}
						// hide rollover image
						document.all[arrTargets[i].targetID].src =
							document.all[arrTargets[i].targetID].regImg;
						break;
					}					
				}
			}
		}
