//----------------------------------------------------------------------------
//	MULTDRAGCODE.JS	- drag and drop implementation for component controls
//					  and closet object.
//----------------------------------------------------------------------------
		

//	TARGET OBJECT DEFINITION--------------------------------------------		
		
		function overTarget(eX, eY) {
//----------------------------------------------------------------------------
//	RETURNS BOOLEAN
//	determines whether the parameter x and y is within the area of the target
//----------------------------------------------------------------------------
			if (((eX > this.totalLeft) && (eX < this.right))
				&& ((eY > this.totalTop) && (eY < this.bottom)))
			{
				return true;			
			}
			if (((eX < this.totalLeft) || (eX > this.right))
				|| ((eY < this.totalTop) || (eY > this.bottom)))
			{
				return false;
			}
		}
	
		function Target(p_strElement, p_strAccept, p_strDrop) {
//----------------------------------------------------------------------------
//	PURPOSE:	constructor of Target object
//	PROPERTIES:
//		targetID	- same as ID of element.
//		offX		- total horizontal offset of parent elements.
//		offY		- total vertical offset of parent elements.
//		totalTop	- horizontal position relative to the screen.
//		totalLeft	- vertical position relative to the screen.
//		bottom		- top + height of element.
//		right		- left + width of element.
//	METHODS:
//		bool overTarget(eX, eY)	
//		bool acceptSource(el)
//		void dropSourceOnTarget(el)
//----------------------------------------------------------------------------
			var elCurrent = document.all[p_strElement];
			
			this.targetID = elCurrent.id;
			
		//-----------------------------------------------------------
		// calculate the offsets of any parent elements
			this.offX = 0;
			this.offY = 0;
			
			var elParent = document.all[this.targetID].offsetParent;
			while (elParent.offsetParent != null)
			{
				this.offX += elParent.offsetLeft;
				this.offY += elParent.offsetTop;
				elParent = elParent.offsetParent;
			}
			
			var posL = elCurrent.style.posLeft;
			var posT = elCurrent.style.posTop;
			
			this.totalTop = posT + this.offY;
			this.totalLeft = posL + this.offX;
		//-------------------------------------------------------------
			
			// width will return NaN if element is scrollable and right is off screen
			if (isNaN(parseInt(elCurrent.width)))
				this.right = eval(this.totalLeft + elCurrent.scrollWidth);
			else
				this.right = eval(parseInt(this.totalLeft) + parseInt(elCurrent.width));
			
			// height will return NaN if element is scrollable and bottom is off screen
			if (isNaN(parseInt(elCurrent.height)))
				this.bottom = eval(parseInt(this.totalTop) + parseInt(elCurrent.scrollHeight));
			else
				this.bottom = eval(parseInt(this.totalTop) + parseInt(elCurrent.height));
									
			// assign methods
			this.overTarget = overTarget;
			this.acceptSource = eval(p_strAccept);
			this.dropSourceOnTarget = eval(p_strDrop);
	
		}

