//----------------------------------------------------------------------------
//	TARGETMETHODS.JS
//		 
//----------------------------------------------------------------------------

		function asMannequin(el) {
//----------------------------------------------------------------------------
//	test whether the mannequin accepts 'el'.
//----------------------------------------------------------------------------
			switch (el.sourceType)
			{
				case "outfit" :
					return true;
				case "dcc" :
					var l_element = document.all[el.sourceID];
					var l_dcc = l_element.Component;
					var l_nCat = l_dcc.GetIntCategory();
					//alert(l_nCat);
					// don't allow shoes, cosmetics, accessories
					switch(l_nCat)
					{
						case  7:
						case 10:
						case 11:
							//alert('bad category: ' + l_nCat);
							return false;
					}
					return true;
			}
			return false;
		}
		
		function dsotMannequin(el) {
//----------------------------------------------------------------------------
//	-	'el' is a Source object. 
//	-	objSource is the Component Control that 'el' wraps.
//	-	objTarget is the Component Control that 'this' (target obj) wraps.
//
//----------------------------------------------------------------------------
			window.external.PlayAudio('dropmann.wav');
			var objSource = document.all[el.sourceID];
			
			var l_strRealTarget = '';
			
			if (this.targetID == "divMannequin1Container")
				l_strRealTarget = 'objMannequin1';
			else if (this.targetID == "divMannequin2Container")
				l_strRealTarget = 'objMannequin2';
			else
				l_strRealTarget = this.targetID;
				
			if (l_strRealTarget == el.sourceID)
			{
				return;
			}
				
			toggleGetItButtons(
				l_strRealTarget.substring((l_strRealTarget.length - 1),
										  (l_strRealTarget.length)));
			var objTarget = document.all[l_strRealTarget];

			switch(el.sourceType)
			{
				case "outfit":
					// delete items on target mannequin!!
					var l_outfitTarget = objTarget.Component;
					var l_ocDccs = l_outfitTarget.getDccCollection();
					l_ocDccs.Empty();

					// add new outfit
					var ocSourceDccs = objSource.Component.getDccCollection();
					for (var i = 0; i < ocSourceDccs.Size; i++)
					{
						
						var objDcc = ocSourceDccs.GetAt(i);
						objTarget.Component.addDcc(objDcc);
						tmpTransaction = 'A';
						if (i == (ocSourceDccs.Size - 1))
						{
							tmpTransaction += 'R'
						}
						else
						{
							tmpTransaction += ' ';
						}
						var pkt = BuildPacket('DCC',tmpTransaction,objDcc.dccID);
					}
					objTarget.DrawComponentOnColor(objTarget.Component, window.external.currentuser.skincolor, 255,255,255);
					break;
				case "dcc" :					
					var sourceDcc = objSource.component;
					var strObjectID = objTarget.component.outfitID;
					objTarget.component.addDcc(sourceDcc);
					objTarget.DrawComponentOnColor(objTarget.Component, window.external.currentuser.skincolor, 255, 255, 255);
					tmpTransaction = 'AR'
					var pkt = BuildPacket('DCC',tmpTransaction,sourceDcc.dccID);
					break;
			}
			
		}
		
		function asCloset(el) {
//----------------------------------------------------------------------------
//	test whether the closet accepts 'el'.
//----------------------------------------------------------------------------
			switch (el.sourceType)
			{
				case "outfit" :
					document.all[this.targetID].style.border="0pt blue solid";
					return true;
			}
			document.all[this.targetID].style.border="0pt blue solid";			
			return false;
		}			
		
		
		function dsotCloset(el) {
//----------------------------------------------------------------------------
//	assumes closet accepts 'el'.
//	perform action based on type of source.
//----------------------------------------------------------------------------
			var objSource = document.all[el.sourceID];
			var objTarget = document.all[this.targetID];

			switch (el.sourceType)
			{
				case "outfit" :					
					//	check to make sure that the outfit was not dragged
					//	from the closet back to the closet.
					var dccColl = objSource.Component.getDCCCollection();
					var nLastDcc = dccColl.Size - 1;

					if ( 0 == dccColl.Size )
						break;

					// This code has been commented out due to
					// a change of functional requirements.
					// A drag from the Mannequin to the closet
					// no longer clears the user's mannequin or
					// the remote user's mannequin.
					// The code below only clears the remote
					// mannequin.
					//remove from both local and remote mannequins
				//	if (el.sourceID == "objMannequin1")
				//	{	
				//		for (var j = 0; j < dccColl.Size; j++ )
				//		{
				//			tmpTransaction = 'R';
				//			if (j == (nLastDcc))
				//			{
				//				tmpTransaction += 'R'
				//			}
				//			else
				//			{
				//				tmpTransaction += ' ';
				//			}
				//			var removedDcc = dccColl.GetAt(j);
				//			var pkt = BuildPacket('DCC',tmpTransaction,removedDcc.dccID);
				//		}
				//	}

					window.external.currentuser.addClosetOutfit(objSource.Component);
					// Only refresh the pick-list of DCC's if the "Outfits" tab is selected
					if (objState.m_nCategory == 1)
					{
						refreshCurrentCategory();
					}
					break;
			}
			window.external.PlayAudio('dragmsup.wav');
		}		

		function asRemove(el) {
//----------------------------------------------------------------------------
//	Returns true if the target accepts the source.
//----------------------------------------------------------------------------
			switch(el.sourceType)
			{
				case "outfit":
					if ((el.sourceID == "objMannequin2")
						&& (window.external.Voice.BuddyName))
					{
						return false;
					}
					else return true;				
				case "dcc":
					window.external.PlayAudio('dragroll.wav');
					return true;
			}
			return false;
		}
		
		function dsotRemove(el) {
//----------------------------------------------------------------------------
//----------------------------------------------------------------------------
			window.external.PlayAudio('removeit.wav');
			var objSource = document.all[el.sourceID];
			var objTarget = document.all[this.targetID];
						
			switch(el.sourceType)
			{
				case "outfit":
					//	make sure the outfit is on a mannequin not in the closet....
					//	also make sure that mannequin2 is not the buddy mannequin, but the
					//	users 2nd mannequin.
					if ((el.sourceID == "objMannequin1") ||
						((el.sourceID == "objMannequin2") && (!window.external.Voice.BuddyName)))
					{		
						// get all the dccs for the source mannequin
						var ocAllDCCs = objSource.component.getDCCCollection();
						var ocSize = ocAllDCCs.Size;
						
						//	remove the dccs from the mannequin
						for (var i = ocSize - 1; i > -1; i--) 
						{
							var removedDcc = ocAllDCCs.GetAt(0);
							objSource.Component.removeDcc(removedDcc);

							tmpTransaction = 'R';
							if (i <= 1)
							{
								tmpTransaction += 'R'
							}
							else
							{
								tmpTransaction += ' ';
							}
							var pkt = BuildPacket('DCC',tmpTransaction,removedDcc.dccID);
						}
						objSource.DrawComponentOnColor(objSource.Component, window.external.currentuser.skincolor, 255,255,255);
					}
					else
					{
						//	...the outfit being dragged is from the closet...				
						//	delete the closet outfit from the user closet, but leave the dccs.
						window.external.currentuser.deleteClosetOutfit(objSource.Component.outfitID);
						refreshCurrentCategory();
					}
					break;
				case "dcc":					
					var l_strDccID = objSource.Component.dccID;	
					
					// 	l_bSuccessfulDelete will return false if dcc is contained in
					//	any outfits...
					var l_bSuccessfulDelete = window.external.currentuser.deleteClosetDcc(l_strDccID, false);
					if (!l_bSuccessfulDelete)
					{
						var strMsg = "The item you are trying to delete is contained\n"
							+ "in at least one outfit. Any outfits that contain this item\n"
							+ "will also be deleted. Continue?";
						if (confirm(strMsg))
						{
							window.external.currentuser.deleteClosetDcc(l_strDccID, true); 
						}
					}
					refreshCurrentCategory();

					break;
			}
		}
