//----------------------------------------------------------------------------
//	EA_DRAGCODE.JS											
//----------------------------------------------------------------------------

		var dropTarget = null;
		var dtTop = 0;
		var dtLeft = 0;
		var dtTopHeight = 0;
		var dtLeftWidth = 0;
				
		var dtSrc = "";
		var dtAltSrc = "";
		
		var elDragged = null;
		var origX;
		var origY;
	
		var boolOnTarget = false;
		
		function findTarget() {
//----------------------------------------------------------------------------
//	This function loops through all the elements on the page, looking for any 
//	that have the DROPTARGET attribute. if found, it tests the attribute for a
//	value of 'yes'. Once an element satisfies these requirements the function 
//	stops. the element is assigned to 'droptarget' and must implement an 
//	'altImg' attribute for the 'doMouseMove' image swap.
//----------------------------------------------------------------------------
			for (var i = 0; i < document.all.length; ++i) {
				var szDT = document.all[i].getAttribute("DROPTARGET");
				if ((szDT != null) && (szDT.toUpperCase() == "YES")) {
					dropTarget = document.all[i];
					dtSrc = dropTarget.src;
					dtAltSrc = dropTarget.getAttribute("altImg");
					dtTop = dropTarget.style.pixelTop;
					dtLeft = dropTarget.style.pixelLeft;
					dtTopHeight = dtTop + dropTarget.height;
					dtLeftWidth = dtLeft + dropTarget.width;
					break;
				}
			}
		}
		
		function doDragOff(id, obj) {
//----------------------------------------------------------------------------
				imgDRoom.src = imgDRoom.regImg;
				boolOnTarget = false;
		}
		
		function doDragOver(id, obj) {
//----------------------------------------------------------------------------
				imgDRoom.src = imgDRoom.altImg;
				boolOnTarget = true;		
				window.external.PlayAudio('dragroll.wav');
		}

		
		function doMouseDown(elCurrent, eX, eY) {
//----------------------------------------------------------------------------
//	elCurrent:	element receiving the mousedown event
//	eX, eY:		screen coordinates of the event
//
//	simulates the built-in onmousedown event.
//----------------------------------------------------------------------------
				window.external.PlayAudio('dragslct.wav');
				elDragged = elCurrent;
				elDragged.x = eX;
				elDragged.y = eY;
		}
		
		
		function doMouseMove(eX, eY) {
//----------------------------------------------------------------------------
//	eX, eY:		coordinates of event
//
//	simulates the built-in onmousemove event.  this function also handles the 
//	dropTarget image switching
//----------------------------------------------------------------------------

				//	test for existence of mouseover target. 
				if (dropTarget != null) {	
					// simulate onmouseover for the target
					if (((eX > dtLeft) && (eX < dtLeftWidth))
						&& ((eY > dtTop) && (eY < dtTopHeight))) {
						//	switch to alternate image
						if (dtAltSrc != null)
							dropTarget.src = dtAltSrc;
						boolOnTarget = true;
						window.external.PlayAudio('dragroll.wav');
					}
					// simulate onmouseout for the target
					if (((eX < dtLeft) || (eX > dtLeftWidth))
						|| ((eY < dtTop) || (eY > dtTopHeight))) {
						//	switch back to original image
						dropTarget.src = dtSrc;
						boolOnTarget = false;
					}
				}
		}
		
		function doMouseUp(eX, eY) {
//----------------------------------------------------------------------------
//	eX, eY:		screen coordinates of the event
//
//	simulates the built-in onmouseup event
//----------------------------------------------------------------------------
			// shorthand
			var wec_user = window.external.currentuser;
			var thisoutfit = elDragged.component;
			
			// LOG THE EVENT
			window.external.currentuser.addEventLog("EAAddToDR",
													thisoutfit.vendorID,
													thisoutfit.outfitID);

			var objDccs = elDragged.component.getDCCCollection();
			
			if (boolOnTarget)
			{				
				window.external.PlayAudio('dragmsup.wav');
				// ROLLOVER DRESSING ROOM ICON
				dropTarget.src = dtSrc;
				wec_user.addOutfit(thisoutfit);
				window.external.PlayAudio('dragmsup.wav');
				saveDRStateInfo();
			}
			elDragged = null;
		}

		function saveDRStateInfo() {
//----------------------------------------------------------------------------
			// save state info in DRState object
			var l_objDRState = window.external.PageState("DR");
			if (!l_objDRState)
				l_objDRState = new DRState();
			l_objDRState.m_strComponentType = "Outfits";
			l_objDRState.m_nCategory = 1;
			l_objDRState.m_strTabSelected = 'imgCatTab1';
			window.external.PageState("DR") = l_objDRState;
		}		