//----------------------------------------------------------------------------
//	DRAGCODE.JS - drag and drop implementation for component controls 		
//															
//----------------------------------------------------------------------------

		var g_elemDropTarget = null;
		var g_nDTTop = 0;
		var g_nDTLeft = 0;
		var g_nDTTopHeight = 0;
		var g_nDTLeftWidth = 0;
				
		var g_strDTSrc = "";
		var g_strDTAltSrc = "";
		
		var g_elemDragged = null;	
		var g_bOnTarget = false;
		
		function findTarget() {
//----------------------------------------------------------------------------
//	This function loops through all the elements on the page, looking for any 
//	that have the DROPTARGET attribute. if found, it tests the attribute for a
//	value of 'yes'. Once an element satisfies these requirements the function 
//	stops. the element is assigned to 'droptarget' and must implement an 
//	'altImg' attribute for the 'doMouseMove' image swap.
//----------------------------------------------------------------------------
			for (var i = 0; i < document.all.length; ++i) {
				var l_strDT = document.all[i].getAttribute("DROPTARGET");
				if ((l_strDT != null) && (l_strDT.toUpperCase() == "YES")) {
					g_elemDropTarget = document.all[i];
					g_strDTSrc = g_elemDropTarget.src;
					g_strDTAltSrc = g_elemDropTarget.getAttribute("altImg");
					
					g_nDTTop = g_elemDropTarget.style.pixelTop;
					g_nDTLeft = g_elemDropTarget.style.pixelLeft;
					g_nDTTopHeight = g_nDTTop + g_elemDropTarget.height;
					g_nDTLeftWidth = g_nDTLeft + g_elemDropTarget.width;					
					break;
				}
			}
		}
		
		function doDragOff(id, obj) {
//----------------------------------------------------------------------------
				imgDRButton.src = imgDRButton.regImg;
				g_bOnTarget = false;
		}
		
		function doDragOver(id, obj) {
//----------------------------------------------------------------------------
				imgDRButton.src = imgDRButton.altImg;
				g_bOnTarget = true;
				window.external.PlayAudio('dragroll.wav');
		}


		
		function doMouseDown(elCurrent, eX, eY) {
//----------------------------------------------------------------------------
//	elCurrent:	element receiving the mousedown event
//	eX, eY:		screen coordinates of the event
//
//	simulates the built-in onmousedown event.
//----------------------------------------------------------------------------
			g_elemDragged = elCurrent;
			g_elemDragged.x = eX;
			g_elemDragged.y = eY;
			window.external.PlayAudio('dragslct.wav');
		}
		
		
		function doMouseMove(eX, eY) {
//----------------------------------------------------------------------------
//	eX, eY:		coordinates of event
//
//	simulates the built-in onmousemove event.  this function also handles the 
//	dropTarget image switching
//----------------------------------------------------------------------------
				
				//	test for existence of mouseover target. 
				if (g_elemDropTarget != null) {	
					// simulate onmouseover for the target
					if (((eX > g_nDTLeft) && (eX < g_nDTLeftWidth))
						&& ((eY > g_nDTTop) && (eY < g_nDTTopHeight))) {
						//window.external.PlayAudio('off.wav');
						window.external.PlayAudio('dragroll.wav');
						//	switch to alternate image
						if (g_strDTAltSrc != null)
						g_elemDropTarget.src = g_strDTAltSrc;
						g_bOnTarget = true;
					}
					// simulate onmouseout for the target
					if (((eX < g_nDTLeft) || (eX > g_nDTLeftWidth))
						|| ((eY < g_nDTTop) || (eY > g_nDTTopHeight))) {
						//	switch back to original image
						g_elemDropTarget.src = g_strDTSrc;
						g_bOnTarget = false;
					}
				}
		}
		
		function doMouseUp(eX, eY) {
//----------------------------------------------------------------------------
//	eX, eY:		screen coordinates of the event
//----------------------------------------------------------------------------
			// shorthand
			var wec_user = window.external.currentuser;
			
			var l_objThisDcc = g_elemDragged.Component;
			var l_objTempVendors = new ActiveXObject("Vendors.Vendors.1");
			var l_objThisVendor = l_objTempVendors.getVendorByID(l_objThisDcc.vendorID);
			
			// LOG THE EVENT
				window.external.currentuser.addEventLog(
									"FFAddToDR",
									l_objThisVendor.vendorID,
									l_objThisDcc.dccID);
									
			if (g_bOnTarget)
			{
				// ROLLOVER DRESSING ROOM ICON
				g_elemDropTarget.src = g_strDTSrc;
				// ADD OUTFIT TO USERS CLOSET
				wec_user.addDcc(l_objThisDcc);
				saveDRStateInfo(l_objThisDcc);
				window.external.PlayAudio('dragmsup.wav');
			}
			g_elemDragged = null;

		}
		
		function saveDRStateInfo(p_objDcc) {
//----------------------------------------------------------------------------
			// save state info in DRState object
			var l_objDRState = window.external.PageState("DR");
			if (!l_objDRState)
				l_objDRState = new DRState();
			l_objDRState.m_strComponentType = "Dccs";
			l_objDRState.m_nCategory = p_objDcc.GetIntCategory();
			l_objDRState.m_strTabSelected = 'imgCatTab' + l_objDRState.m_nCategory;
			window.external.PageState("DR") = l_objDRState;		
	}