//----------------------------------------------------------------------------
//	DLG_FAVSTORES.JS
//	
//----------------------------------------------------------------------------

	var ocFavVendors = null;
	var ocNonFavVendors = null;	
	var objPathCtrl = null;

	function initPage() {
//----------------------------------------------------------------------------
		objPathCtrl = createPathControlObject("LOGO");

		displayVendorLists();
		
	// ADD CODE TO DISPLAY THE LOGOS OF THE VENDORS
		displayFavoriteLogos();

		window.external.EndWaitCursor();
	}

	function clearVendorLists() {
//----------------------------------------------------------------------------
		var nSelectPos = selectFavStores.options.length - 1;
		while (nSelectPos > -1)
		{
			selectFavStores.options.remove(nSelectPos);
			--nSelectPos;
		}
		nSelectPos = selectAllStores.options.length - 1;
		while (nSelectPos > -1)
		{
			selectAllStores.options.remove(nSelectPos);
			--nSelectPos;
		}
	}

	function displayVendorLists(p_list){
//----------------------------------------------------------------------------	
		clearVendorLists();
	
		// populate favorite vendor select box
		ocFavVendors = window.external.currentuser.getFavoriteVendors();
		for (var i = 0; i < ocFavVendors.Size; i++)
		{
			var objVendor = ocFavVendors.GetAt(i);
			var elOption = document.createElement("OPTION");
			elOption.text = objVendor.name;
			selectFavStores.options.add(elOption, 0);
		}
		
		// INSERT ALL OTHER VENDORS INTO OTHER SELECT BOX
		//populate all vendor select box
		ocNonFavVendors = window.external.currentuser.getNonFavoriteVendors();
		for (var j = 0; j < ocNonFavVendors.Size; j++) 
		{
			var objTempVendor = ocNonFavVendors.GetAt(j);
			//alert(objTempVendor.name);
			if ((objTempVendor.name == "Fashion Basics") ||
				(objTempVendor.name == "Mall")||
				(objTempVendor.name == "the Mall"))
				continue;
			var elOption = document.createElement("OPTION");			
			elOption.text = objTempVendor.name;
			selectAllStores.options.add(elOption, 0);
		}
		sortList('selectFavStores');
		sortList('selectAllStores');

		displayFavoriteLogos();
	}

	function getSelected(optColl) {
//----------------------------------------------------------------------------
		var selected = new Array();
		var index = 0;
		for (var i = 0; i < optColl.length; i++) {
			if (optColl[i].selected) {
				index = selected.length;
				selected[index] = new Object;
				selected[index].text = optColl[i].text;
				selected[index].index = i;
			}
		}
		return selected;
	}


	function clickedAdd() {
//----------------------------------------------------------------------------
		var l_index = selectAllStores.selectedIndex;
		window.external.PlayAudio('gmouseup.wav');
		var vendorToAdd = null;
		var opt = selectAllStores.options;
		var selItems = getSelected(selectAllStores.options);
		
		if (selItems.length == 0) return;

		// add the new items to selectFavStores
		for (var i = 0; i < selItems.length; i++)
		{
			for (var j = 0; j < ocNonFavVendors.Size; j++)
			{
				var tempVend = ocNonFavVendors.GetAt(j);
				if (selItems[i].text == tempVend.name)
				{
					vendorToAdd = tempVend;
					break;
				}
			}
			window.external.currentuser.addFavoriteVendor(vendorToAdd);
		}
		
		displayVendorLists();
		
		// reselect option number
		if ((l_index == selectAllStores.options.length))		
			selectAllStores.selectedIndex = l_index - 1;
		else
			selectAllStores.selectedIndex = l_index;
	}

	function clickedRemove() {
//----------------------------------------------------------------------------
		var l_index = selectFavStores.selectedIndex;
		window.external.PlayAudio('gmouseup.wav');
		var vendorToRemove = null;
		var opt = selectFavStores.options;
		var selItems = getSelected(selectFavStores.options);
		if (selItems.length == 0) return;

		// remove items from selectFavStores
		for (var i = 0; i < selItems.length; i++)
		{
			for (var j = 0; j < ocFavVendors.Size; j++)
			{
				var tempVend = ocFavVendors.GetAt(j);
				if (selItems[i].text == tempVend.name)
				{
					vendorToRemove = tempVend;
					break;
				}
			}
			window.external.currentuser.deleteFavoriteVendor(vendorToRemove);
		}			
		
		displayVendorLists();
		
		// reselect option number
		if ((l_index == 0) || (l_index > selectFavStores.options.length))
			selectFavStores.selectedIndex = l_index;
		else
			selectFavStores.selectedIndex = l_index - 1;
	}
	
	function sortList(strList) {
//----------------------------------------------------------------------------
		listOpts = document.all[strList].options;
		
		// create an array of the list options
		var arrListOpts = new Array();
		
		// remove all the options for strList
		for (var i = listOpts.length - 1; i >= 0; i--) 
		{
			arrListOpts[i] = listOpts(i).text;
			listOpts.remove(i);
		}
		
		arrListOpts.sort();
		
		// rebuild strList with the sorted array
		for (var i = arrListOpts.length - 1; i >= 0 ; i--) 
		{
			var optTemp = document.createElement("OPTION");
			optTemp.text = arrListOpts[i];
			listOpts.add(optTemp, 0);
		}
	}
	
	function displayFavoriteLogos() {
//----------------------------------------------------------------------------
		clearLogos();
		var strHTML = '';
		for (var i = 0; i < ocFavVendors.Size; i++)
		{
			var thisVendor = ocFavVendors.GetAt(i);
			
			// build logo filename
			var strTemp = "";
			for ( j = 0 ; j < (6 - thisVendor.vendorID.length) ; j++)
			{
				strTemp += "0";
			}
			var l_strLogoFileName = strTemp + thisVendor.vendorID + '.jpg';
			var l_strFullPath = getFullPath(objPathCtrl,
											thisVendor.VendorID,
											l_strLogoFileName);

			strHTML += '<img src="' + l_strFullPath + '" ';
			strHTML += 'height=60 ';
			strHTML += 'hspace=5 ';
			strHTML += 'id="' + thisVendor.VendorID + '" ';
			strHTML += 'onclick="window.parent.clickedVendorLogo(this.id)">';
		}
		iframeVendorLogos.tablecellLogos.innerHTML = strHTML;
	}
	
	function clearLogos(){
//----------------------------------------------------------------------------
		iframeVendorLogos.tablecellLogos.innerHTML = '';
	}
	
	function clickedVendorLogo(p_strVendorID) {
//----------------------------------------------------------------------------
		window.external.PlayAudio('gmouseup.wav');
		
		// make sure the selected vendor has a store before going to vr
		//alert(p_strVendorID);
		var l_objVendors = new ActiveXObject("Vendors.Vendors.1");
		var l_objVendor = l_objVendors.getVendorByID(p_strVendorID);
		//alert(l_objVendor.name);
		if (l_objVendor.isValid == '0')
		{
			if (window.external.Version() == 0)
			{
				alert('This is a new manufacturer.\n'
						+ 'Please go to the Update Manager to download'
						+ ' their store.');
			}
			else
			{
				alert('This manufacturer does not have a store in this version of Fashion Trip.');
			}
			return;
		}
		
		if (l_objVendor.isValid == '1')
		{
			alert('This manufacturer does not have a store in this version of Fashion Trip.\n'
					+ 'However, their products are available in the Fashion Finder.');
			return;
		}
		
		
		var l_objVRState = window.external.PageState("VR");
		
		if (!l_objVRState)
		{
			l_objVRState = new VRState(parseInt(p_strVendorID));
			window.external.PageState("VR") = l_objVRState;
		}
		else
		{
			l_objVRState.m_nVendorID = parseInt(p_strVendorID);
			window.external.PageState("VR") = l_objVRState;
		}
		window.external.PageState("VR").m_bChanged = true;
		window.external.closeBrowser();
	}
	
	function clickedClose() {
//----------------------------------------------------------------------------
		window.external.PlayAudio('gmouseup.wav');
		window.external.closeBrowser();
	}
