//----------------------------------------------------------------------------
//	OPTIONS_MAIN.JS
//----------------------------------------------------------------------------

	function initPage() {
//----------------------------------------------------------------------------
		fillInternetSettings();
		fillMallSetting();
		fillSoundSetting();
		fillAddBookSettings();
		window.external.EndWaitCursor();
	}
	
//----------------------------------------------------------------------------
//	INTERNET
//----------------------------------------------------------------------------

	var TEMP_CONNECTION_METHOD = window.external.NetConnect1.GetConnectionMethod();
	var g_strDUNOptions = window.external.NetConnect1.GetList();

	function fillInternetSettings() {
//----------------------------------------------------------------------------

		// reflect connection status
		toggleConnectionButtons();
		
		var DUNAvailable = window.external.NetConnect1.IsDUNAdapter();
		var AOLAvailable = window.external.NetConnect1.IsAOLAdapter();
		var LANAvailable = window.external.NetConnect1.IsLANAdapter();

		//set ISP Button
		if (DUNAvailable)
		{
			radioConnection[0].disabled = false;
		}
		else
		{
			radioConnection[0].disabled = true;
		}

		//set AOL button
		if (AOLAvailable)
		{
			radioConnection[1].disabled = false;
		}
		else
		{
			radioConnection[1].disabled = true;
		}

		//set LAN Button
		if (LANAvailable)
		{
			radioConnection[2].disabled = false;
		}
		else
		{
			radioConnection[2].disabled = true;
		}

		// show connection method
		for (i = 0; i < radioConnection.length; i++)
		{
			if (radioConnection[i].value == TEMP_CONNECTION_METHOD)
			{	
				radioConnection[i].checked = true;
				break;
			}
		}
		fillDUNOptions();
		clickedRadioConnection(TEMP_CONNECTION_METHOD);
	}

	function toggleConnectionButtons() {
//----------------------------------------------------------------------------
		buttonConnect.disabled = window.external.NetConnect1.IsConnected();
		buttonDisconnect.disabled = !buttonConnect.disabled;
	}

	function clickedConnect() {
//----------------------------------------------------------------------------
		initConnection();
		if (window.external.Voice != null)
		{
			var l_strUserName =	window.external.currentuser.firstname 
								+ ' ' + window.external.currentuser.lastname;
			window.external.Voice.Hangup();
			window.external.Voice.Listen(l_strUserName, window.external.currentuser.email);
		}

		toggleConnectionButtons();
	}

	function clickedDisconnect() {
//----------------------------------------------------------------------------
		window.external.NetConnect1.Disconnect();	
		if (window.external.Voice != null)
		{
			var l_strUserName =	window.external.currentuser.firstname 
								+ ' ' + window.external.currentuser.lastname;
			window.external.Voice.Hangup();
			window.external.Voice.Listen(l_strUserName, window.external.currentuser.email);
		}
		toggleConnectionButtons();		
	}


	function fillDUNOptions() {
//----------------------------------------------------------------------------
		if (g_strDUNOptions.length == 0)
		{
			radioISP.checked = false;
			radioISP.disabled = true;
		}
		
		var arrChoices = g_strDUNOptions.split(",");

		for (i = 0; i < arrChoices.length; i++)
		{
			var l_opt = document.createElement("OPTION");
			l_opt.text = arrChoices[i];
			
			// add new option to select listbox
			var l_nSelectLength = selectDialupConnection.options.length;
			selectDialupConnection.options.add(l_opt, l_nSelectLength);
		}
		
		// display the currently selected method		
		var l_strDefaultConn = window.external.NetConnect1.GetDefaultISP();
		for (j = 0; j < selectDialupConnection.options.length; j++)
		{
			if (l_strDefaultConn == selectDialupConnection[j].text)
			{
				selectDialupConnection.selectedIndex = j;
			}		
		}
	}

	function clickedRadioConnection(p_strRadioValue) {
//----------------------------------------------------------------------------
		// TODO: SAVE CONNECTION METHOD

		switch(p_strRadioValue)
		{
			case 'ISP':
				selectDialupConnection.disabled = false;
				// make sure a phonebook entry exists before passing it to the method
				if (selectDialupConnection.selectedIndex > -1)
				{
					window.external.NetConnect1.SetConnectionMethod("Dial-Up Networking",
						selectDialupConnection[selectDialupConnection.selectedIndex].text);
				}
				else
				{
					alert( "No Dial-Up Networking connections available.\n");
					radioISP.checked = false;
					radioISP.disabled = true;
					
					// fill in a blank option 
					var l_opt = document.createElement("OPTION");
					l_opt.text = "          ";
					selectDialupConnection.options.add(l_opt, 0);
					
					selectDialupConnection.disabled = true;
					window.external.NetConnect1.SetConnectionMethod("none","");
				}
				break;
			case 'AOL':
				selectDialupConnection.disabled = true;
				window.external.NetConnect1.SetConnectionMethod("AOL","");
				break;
			case 'LAN':
				selectDialupConnection.disabled = true;
				window.external.NetConnect1.SetConnectionMethod("LAN","");
				break;
			default:
				window.external.NetConnect1.SetConnectionMethod("none","");
				break;

		}
	}

	function onDialupConnectionSelect() {
//----------------------------------------------------------------------------
		window.external.NetConnect1.SetConnectionMethod("Dial-Up Networking",
				selectDialupConnection[selectDialupConnection.selectedIndex].text);
	}

//----------------------------------------------------------------------------
//	MALL
//----------------------------------------------------------------------------

	function fillMallSetting() {
//----------------------------------------------------------------------------
		// fill in visual quality settings
		switch(window.external.VisualQuality)
		{
			case 0:
				checkHardware.checked = true;
				radioVQGood.checked = true;
				toggleVQRadios(false);
				break;
			case 1:
				radioVQGood.checked = true;
				break;
			case 2:
				radioVQBetter.checked = true;
				break;
			case 3:
				radioVQBest.checked = true;
				break;			
		}

		if(window.external.UseFlatMundo)
		{
			radioFlatMundo.checked = true;
			checkHardware.disabled = true;
			toggleVQRadios(false);
		}
		else 
		{
			radioTDMundo.checked = true;
			checkHardware.disabled = false;
			if(checkHardware.checked)
				toggleVQRadios(false);
			else
				toggleVQRadios(true);
		}
	}

	
	function clickedRadioMundoVersion(p_elemRadio) {
//----------------------------------------------------------------------------
		window.external.UseFlatMundo = p_elemRadio.value;
		if(p_elemRadio.value == 'true')
		{
			toggleVQRadios(false);
			checkHardware.disabled = true;
		}
		else
		{
			checkHardware.disabled = false;
			toggleVQRadios(!checkHardware.checked);
		}
	}		

	function toggleHardwareAcc() {
//----------------------------------------------------------------------------
		if (checkHardware.checked)
		{
			window.external.VisualQuality = 0;
			toggleVQRadios(false);
		}
		else
		{
			toggleVQRadios(true);
			var l_valid = false;
			for (i = 0; i < radioVQ.length; i++)
			{
				if(radioVQ[i].checked)
				{
					l_valid = true;
					window.external.VisualQuality = radioVQ[i].value;
				}
			}
			if (!l_valid)
			{
				radioVQ[0].checked = true;
				window.external.VisualQuality = radioVQ[0].value;
			}
		}
	}

	
	function toggleVQRadios(p_bEnabled) {
//----------------------------------------------------------------------------
		if (p_bEnabled)
		{
			for(i = 0; i < radioVQ.length; i++)
				radioVQ[i].disabled = false;
		}
		else
		{
			for(i = 0; i < radioVQ.length; i++)
				radioVQ[i].disabled = true;		
		}
	}

	function clickedVQRadio(p_nVQ) {
//----------------------------------------------------------------------------
		//alert(p_nVQ);
		window.external.VisualQuality = p_nVQ;
	}
//----------------------------------------------------------------------------
//	SOUND
//----------------------------------------------------------------------------
	
	function fillSoundSetting() {
//----------------------------------------------------------------------------
		checkSound.checked = !window.external.IsSoundEnabled;
	}	
	
	function toggleSound() {
//---------------------------------------------------------------------------- 
		window.external.IsSoundEnabled = !checkSound.checked;
	}
		
//----------------------------------------------------------------------------
//	ADDRESS BOOK
//----------------------------------------------------------------------------
	
	function fillAddBookSettings() {
//----------------------------------------------------------------------------
		checkPhone.checked = !window.external.IsIPhoneEnabled;
	}
	
	function togglePhone() {
//----------------------------------------------------------------------------
		window.external.IsIPhoneEnabled = !checkPhone.checked;
	}

//----------------------------------------------------------------------------
//	ONUNLOAD	
//----------------------------------------------------------------------------

	function clickedUpdateManager() {
//----------------------------------------------------------------------------
		window.external.PoliteCancelPush();
		window.location.href="options2_main.html"
	}
